<?php
class ControllerExtensionModuleCloudinvoice extends Controller {
    private $error = array();

    public function index() {
        $this->load->language('extension/module/cloudinvoice');

        $this->document->setTitle($this->language->get('heading_title'));

        $this->load->model('setting/setting');

        if (($this->request->server['REQUEST_METHOD'] == 'POST') && $this->validate()) {

            $arr['module_cloudinvoice_status'] = $this->request->post['module_cloudinvoice_status'];
            $this->model_setting_setting->editSetting('module_cloudinvoice', $arr);

            $postArray = array_map('trim', $this->request->post);

            $this->model_setting_setting->editSetting('cloudinvoice', $postArray);
            
            $this->session->data['success'] = $this->language->get('text_success');
            $this->response->redirect($this->url->link('extension/module/cloudinvoice', 'user_token=' . $this->session->data['user_token'], 'SSL'));
        }

        $data = $this->init();
        $data['statuses'] = json_encode($this->getStatuses());

        $this->load->language('extension/module/cloudinvoice');

        $data['heading_title'] = $this->language->get('heading_title');
        $data['text_edit'] = $this->language->get('text_edit');
        $data['text_enabled'] = $this->language->get('text_enabled');
        $data['text_disabled'] = $this->language->get('text_disabled');

        $data['entry_status'] = $this->language->get('entry_status');

        $data['text_invoicesystem'] = $this->language->get('invoicesystem');
        $data['text_cloudinvoiceurl'] = $this->language->get('cloudinvoiceurl');
        $data['text_cloudinvoiceapikey'] = $this->language->get('cloudinvoiceapikey');
        //$data['text_name'] = $this->language->get('name');
        $data['text_URL_platform'] = $this->language->get('URL_platform');
        $data['text_Licensekey'] = $this->language->get('Licensekey');
        $data['text_api_key'] = $this->language->get('api_key');
        $data['text_loading'] = $this->language->get('loading');
        $data['button_save'] = $this->language->get('button_save');
        $data['button_cancel'] = $this->language->get('button_cancel');

        $data['invoicesystems'] = ['factuursturen'=>'Factuursturen', 'exactonline'=>'Exact Online', 'reeleezee'=>'Reeleezee', 'moneybird'=>'MoneyBird', 'imuis'=>'Muis', 'twinfieldtransacties'=>'Twinfield transacties', 'twinfieldfacturen'=>'Twinfield facturen', 'yuki'=>'Yuki', 'cash'=>'Cash', 'asperion'=>'Asperion', 'factuursturen'=>'Factuursturen', 'eboekhouden'=>'e-Boekhouden.nl'];

        if (isset($this->error['warning'])) {
        $data['error_warning'] = $this->error['warning'];
        } else {
        $data['error_warning'] = '';
        }

        $data['entry_key'] = $this->language->get('entry_key');
        if (isset($this->request->post['cloudinvoice_api_key'])) {
        $data['cloudinvoice_api_key'] = $this->request->post['cloudinvoice_api_key'];
        } else {
        $data['cloudinvoice_api_key'] = $this->config->get('cloudinvoice_api_key');
        }

        $data['breadcrumbs'] = array();

        $data['breadcrumbs'][] = array(
                                             'text'      => $this->language->get('text_home'),
                                             'href'      => $this->url->link('common/home', 'user_token=' . $this->session->data['user_token'], 'SSL'),
                                             'separator' => false
                                       );

        $data['breadcrumbs'][] = array(
                                             'text'      => $this->language->get('text_module'),
                                             'href'      => $this->url->link('extension/module', 'user_token=' . $this->session->data['user_token'], 'SSL'),
                                             'separator' => ' :: '
                                       );

        $data['breadcrumbs'][] = array(
                                             'text'      => $this->language->get('heading_title'),
                                             'href'      => $this->url->link('extension/module/featured', 'user_token=' . $this->session->data['user_token'], 'SSL'),
                                             'separator' => ' :: '
                                            );


        $data['action'] = $this->url->link('extension/module/cloudinvoice', 'user_token=' . $this->session->data['user_token'], 'SSL');

        $data['cancel'] = $this->url->link('extension/module', 'user_token=' . $this->session->data['user_token'], 'SSL');

        if (isset($this->request->post['module_cloudinvoice_status'])) {
            $data['module_cloudinvoice_status'] = $this->request->post['module_cloudinvoice_status'];
        } else {
            $data['module_cloudinvoice_status'] = $this->config->get('module_cloudinvoice_status');
        }

        //Version OpenCart 2.x
        $data['header'] = $this->load->controller('common/header');
        $data['column_left'] = $this->load->controller('common/column_left');
        $data['footer'] = $this->load->controller('common/footer');

        if( $data['cloudinvoiceinvoicesystem'] == 'twinfieldtransacties' || $data['cloudinvoiceinvoicesystem'] == 'twinfieldfacturen' ){
            $data['cloudinvoiceinvoicesystem'] = 'twinfield';
        }

        $cikey = $data['cloudinvoiceapikey'];
        $webshopurl = 'http' . ((isset($_SERVER['HTTPS']) && $_SERVER['HTTPS']) ? 's' : '') . '://' . $_SERVER['HTTP_HOST'];
        $data['url'] = 'https://interface.cloudinvoice.company/api/v1/view/opencart-'.$data['cloudinvoiceinvoicesystem'].'/settings.php?cikey='.$cikey.'&webshopurl='.$webshopurl.'&statuses='.$data['statuses'];
        $data['url2'] = 'https://interface.cloudinvoice.company/api/v1/view/opencart-'.$data['cloudinvoiceinvoicesystem'].'/syncproducts.php?cikey='.$cikey;

        $this->response->setOutput($this->load->view('extension/module/cloudinvoice', $data));
    }

    protected function validate() {
        if (!$this->user->hasPermission('modify', 'extension/module/cloudinvoice')) {
            $this->error['warning'] = $this->language->get('error_permission');
        }

        return !$this->error;
    }

    private function getStatuses() {
        $query = $this->db->query("SELECT * FROM `" . DB_PREFIX . "order_status`");
        $statuses = $query->rows;

        $arrKeySort = array();
        foreach ($statuses as $st) {
            $arrKeySort[] = $st['order_status_id'];
        }
        array_multisort($arrKeySort, $statuses);
        $returnstats = array();
        foreach ($statuses as $st) {
            $stat = array();
            $stat['id'] = $st['order_status_id'];
            $stat['name'] = $st['name'];
            $returnstats[] = $stat;
        }
        return $returnstats;
    }

    private function init() {
        $settings = $this->model_setting_setting->getSetting('cloudinvoice'); //To do, retrieve correct values        
        if (!isset($settings['cloudinvoiceapikey'])) {
            $settings['cloudinvoiceapikey'] = '';
        }
        if (!isset($settings['cloudinvoice_api_key'])) {
            $settings['cloudinvoice_api_key'] = '';
        }
        if (!isset($settings['cloudinvoiceinvoicesystem'])) {
            $settings['cloudinvoiceinvoicesystem'] = '';
        }
        return $settings;
    }
}